%%
% Implement your own code for image filtering, my_imfilter() in MATLAB
% or C++ (You will get extra credit if you use C++). 
% It must 
% (1) support grayscale and color images 
% (2) support arbitrary shaped filters, as long as both dimensions are odd 
%   (e.g. 7x9 filters but not 4x5 filters) 
% (3) pad the input image with zeros or reflected image content and 
% (4) return a filtered image which is the same resolution as the input image. 
% Test your program on the provided images.
% 
% Forbidden MATAB functions which you cannot use in your final code: 
% imfilter(), filter2(), conv2(), nlfilter(), colfilt().
%
% sungjoon.s.choi@gmail.com
%  
ccc

%% 1. Load image to 'img'
% select image
img_idx = 1;
img_full_path = get_img_path(img_idx);
% load selected image
img = imread(img_full_path);

%% 2. Do image filtering (UINT8)
raw_img = img;
fw = 9;
fh = 9;
filter = ones(fh, fw);
filter = filter/sum(sum(filter));
fimg_matlab = imfilter(raw_img, filter);
fimg_mine = my_imfilter(raw_img, filter);

% plot
fig = figure(2); clf;
subaxes(fig, 2, 2, 1);
imshow(raw_img);
title('Raw Image', 'FontSize', 11);
subaxes(fig, 2, 2, 2);
imshow(fimg_mine);
title('Filtered Image (mine)', 'FontSize', 11);
subaxes(fig, 2, 2, 3);
imshow(fimg_matlab);
title('Filtered Image (solution from MATLAB)', 'FontSize', 11);
subaxes(fig, 2, 2, 4);
diff_img = fimg_matlab - fimg_mine;
imshow(diff_img); 
% compute error
nr_ch = size(diff_img, 3);
diff = 0;
for i = 1:nr_ch
    temp_img = diff_img(:, :, i);
    diff = diff + norm(double(temp_img));
end
title(['Error btw Mine and Matlab is ' num2str(diff, '%.1e')], 'FontSize', 11);


%%









